// -*- Mode:C++ -*-
//Header:
//File: slist.h
//Title: sequential list
//Author: NODA Itsuki
//Date: 1998/3/27
//EndHeader:

//ModifyHistory:
// 1998/3/27: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

#ifndef _slist_h_
#define _slist_h_
////////////////////////////////////////////////////////////////////////

#include "base.h"
#include "aheap.h"

//======================================================================
// SList<Content>
//
template <class _Contents_>
class SList {
   public:
      //--------------------------------------------------
      // LocalTypeDef
      typedef SList<_Contents_> slist_t ; 
      typedef _Contents_ cont_t ;

      cont_t element ;
      slist_t* next ;

      inline SList<_Contents_>() {
	 next = NULLPTR ;
      } ;
      inline SList<_Contents_>(const cont_t e) {
	 element = e ;
	 next = NULLPTR ;
      } ;
      inline SList<_Contents_>(const cont_t e, slist_t* n) {
	 element = e ;
	 next = n ;
      } ;

      inline void init() {
	 next = NULLPTR ;
      } ;

      inline bool endp() const { return this == NULLPTR ; } ;

      inline cont_t nth(const UInt n) const {
	 slist_t* p = (slist_t*)this ;
	 for(UInt i = 0 ; i < n ; i++) 
	    if(p != NULLPTR) 
	       p = p->next ;
	 return p->element ;
      } ;

      inline friend ostream& operator<< (ostream& o, const slist_t& sl) {
	 o << &sl ;
	 return o ;
      } ;
      inline friend ostream& operator<< (ostream& o, const slist_t* sl) {
	 o << "#SeqList[" ;
	 for(slist_t* p = (slist_t*)sl ; !(p->endp()) ; p = p->next ) 
	    o << p->element ;
	 o << "]" ;
	 return o ;
      } ;
	       
} ;

//======================================================================
// SListHeap<Content>
//
template <class _Contents_>
class SListHeap : public AHeap< SList<_Contents_> > {
   public:	
      //--------------------------------------------------
      // LocalTypeDef
      typedef SList<_Contents_>	slist_t ;
      typedef SListHeap<_Contents_> slheap_t ; 
      typedef _Contents_ cont_t ;

      inline slist_t* push(cont_t el, slist_t* nx) {
	 slist_t* newlist = get() ;
	 newlist->element = el ;
	 newlist->next = nx ;
	 return newlist ;
      } ;

} ;


     
     

	  
			      
     
     

////////////////////////////////////////////////////////////////////////
#endif
