// -*- Mode:C++ -*-
//Header:
//File: bipred.h
//Title: built-in predicate 
//Author: NODA Itsuki
//Date: 1998/6/19
//EndHeader:

//ModifyHistory:
// 1998/6/19: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

#ifndef _BIPRED_H_
#define _BIPRED_H_
////////////////////////////////////////////////////////////////////////

class Gem ;

//======================================================================
// Funcs
//

extern bool bip_true(Gem* gem) ;
extern bool bip_and(Gem* gem) ;
extern bool bip_cut(Gem* gem) ;
extern bool bip_repeat(Gem* gem) ;
extern bool bip_eq(Gem* gem) ;

extern bool bip_halt(Gem* gem) ;

extern bool bip_trace(Gem* gem) ;
extern bool bip_systrace(Gem* gem) ;
extern bool bip_notrace(Gem* gem) ;
extern bool bip_showstate(Gem* gem) ;
extern bool bip_showenv(Gem* gem) ;

extern bool bip_load(Gem* gem) ;
extern bool bip_listing(Gem* gem) ;
extern bool bip_listsymbol(Gem* gem) ;

extern bool bip_newcell(Gem* gem) ;
extern bool bip_push(Gem* gem) ;
extern bool bip_pop(Gem* gem) ;
extern bool bip_remove_cell(Gem* gem) ;
extern bool bip_remove_a_cell(Gem* gem) ;
extern bool bip_environment(Gem* gem) ;
extern bool bip_in_env(Gem* gem) ;

extern bool bip_asserta_fact(Gem* gem) ;
extern bool bip_assertz_fact(Gem* gem) ;
extern bool bip_asserta_rule(Gem* gem) ;
extern bool bip_assertz_rule(Gem* gem) ;

extern bool bip_write(Gem* gem) ;
extern bool bip_nl(Gem* gem) ;

extern bool bip_inc(Gem* gem) ;
extern bool bip_dec(Gem* gem) ;
extern bool bip_comp_gt(Gem* gem) ;
extern bool bip_comp_ge(Gem* gem) ;
extern bool bip_comp_lt(Gem* gem) ;
extern bool bip_comp_le(Gem* gem) ;

extern bool bip_is(Gem* gem) ;

extern bool bip_ctime(Gem* gem) ;
extern bool bip_utimedif(Gem* gem) ;
extern bool bip_sleep(Gem* gem) ;
extern bool bip_msleep(Gem* gem) ;
extern bool bip_usleep(Gem* gem) ;
extern bool bip_sleep_forever(Gem* gem) ;

extern bool bip_fork(Gem* gem) ;
extern bool bip_pid(Gem* gem) ;

extern bool bip_newbarrier(Gem* gem) ;
extern bool bip_barrier_wait(Gem* gem) ;
extern bool bip_barrier_signal(Gem* gem) ;

extern bool bip_gensym(Gem* gem) ;

extern bool bip_assign_gdbox(Gem* gem) ;
extern bool bip_gdbox_get(Gem* gem) ;
extern bool bip_gdbox_put(Gem* gem) ;

extern bool bip_var(Gem* gem) ;
extern bool bip_issymbol(Gem* gem) ;
extern bool bip_isinteger(Gem* gem) ;
extern bool bip_isfloat(Gem* gem) ;
extern bool bip_isnumber(Gem* gem) ;
extern bool bip_isstring(Gem* gem) ;
extern bool bip_ispointerg(Gem* gem) ;
extern bool bip_term_arity(Gem* gem) ;
extern bool bip_term_argv(Gem* gem) ;



////////////////////////////////////////////////////////////////////////
#endif
