#include "gglobal.h"

GData NullSymbol ;
GData AnonymousVar ;
GData ErrorSymbol ;
GData EOFSymbol ;
GData YesSymbol ;
GData NoSymbol ;
GData ForceSymbol ;
GData RuleOpSymbol ;
GData FactOpSymbol ;
GData TrueSymbol ;
GData FalseSymbol ;
GData AndSymbol ;
GData CutSymbol ;
GData A_PISymbol ;
GData A_AddSymbol ;
GData A_SubSymbol ;
GData A_MulSymbol ;
GData A_DivSymbol ;
GData GenSymSeedSymbol ;
GData ConsSymbol ;
GData ConsCarVar ;
GData ConsCdrVar ;
GData ConsTerm ;
GCell* BasicCell ;
GCell* MainCell ;

void gglobalInit() {
    NullSymbol = GSymbol("$") ;
    AnonymousVar = GVariable("_") ;
    ErrorSymbol = GSymbol("$error") ;
    EOFSymbol = GSymbol("$eof") ;
    YesSymbol = GSymbol("yes") ;
    NoSymbol = GSymbol("no") ;
    ForceSymbol = GSymbol("force") ;
    RuleOpSymbol = GSymbol("$rule") ;
    FactOpSymbol = GSymbol("$fact") ;
    TrueSymbol = GSymbol("$true") ;
    _SymVal(TrueSymbol)->setfunc(bip_true) ;
    FalseSymbol = GSymbol("$false") ;
    AndSymbol = GSymbol("$and") ;
    _SymVal(AndSymbol)->setfunc(bip_and) ;
    CutSymbol = GSymbol("$cut") ;
    _SymVal(CutSymbol)->setfunc(bip_cut) ;
    _SymVal(GSymbol("!"))->setfunc(bip_cut) ;
    _SymVal(GSymbol("$repeat"))->setfunc(bip_repeat) ;
    _SymVal(GSymbol("$halt"))->setfunc(bip_halt) ;
    _SymVal(GSymbol("$eq"))->setfunc(bip_eq) ;
    _SymVal(GSymbol("$trace"))->setfunc(bip_trace) ;
    _SymVal(GSymbol("$systrace"))->setfunc(bip_systrace) ;
    _SymVal(GSymbol("$notrace"))->setfunc(bip_notrace) ;
    _SymVal(GSymbol("$showstate"))->setfunc(bip_showstate) ;
    _SymVal(GSymbol("$showenv"))->setfunc(bip_showenv) ;
    _SymVal(GSymbol("$load"))->setfunc(bip_load) ;
    _SymVal(GSymbol("$listing"))->setfunc(bip_listing) ;
    _SymVal(GSymbol("$listsymbol"))->setfunc(bip_listsymbol) ;
    _SymVal(GSymbol("$newcell"))->setfunc(bip_newcell) ;
    _SymVal(GSymbol("$push"))->setfunc(bip_push) ;
    _SymVal(GSymbol("$pop"))->setfunc(bip_pop) ;
    _SymVal(GSymbol("$remove_cell"))->setfunc(bip_remove_cell) ;
    _SymVal(GSymbol("$remove_a_cell"))->setfunc(bip_remove_a_cell) ;
    _SymVal(GSymbol("$environment"))->setfunc(bip_environment) ;
    _SymVal(GSymbol("$in_env"))->setfunc(bip_in_env) ;
    _SymVal(GSymbol("$asserta_fact"))->setfunc(bip_asserta_fact) ;
    _SymVal(GSymbol("$assertz_fact"))->setfunc(bip_assertz_fact) ;
    _SymVal(GSymbol("$asserta_rule"))->setfunc(bip_asserta_rule) ;
    _SymVal(GSymbol("$assertz_rule"))->setfunc(bip_assertz_rule) ;
    _SymVal(GSymbol("$write"))->setfunc(bip_write) ;
    _SymVal(GSymbol("$nl"))->setfunc(bip_nl) ;
    _SymVal(GSymbol("$inc"))->setfunc(bip_inc) ;
    _SymVal(GSymbol("$dec"))->setfunc(bip_dec) ;
    _SymVal(GSymbol("$comp_gt"))->setfunc(bip_comp_gt) ;
    _SymVal(GSymbol("$comp_ge"))->setfunc(bip_comp_ge) ;
    _SymVal(GSymbol("$comp_lt"))->setfunc(bip_comp_lt) ;
    _SymVal(GSymbol("$comp_le"))->setfunc(bip_comp_le) ;
    _SymVal(GSymbol("$is"))->setfunc(bip_is) ;
    A_PISymbol = GSymbol("pi") ;
    A_AddSymbol = GSymbol("add") ;
    A_SubSymbol = GSymbol("sub") ;
    A_MulSymbol = GSymbol("mul") ;
    A_DivSymbol = GSymbol("div") ;
    _SymVal(GSymbol("$ctime"))->setfunc(bip_ctime) ;
    _SymVal(GSymbol("$utimedif"))->setfunc(bip_utimedif) ;
    _SymVal(GSymbol("$sleep"))->setfunc(bip_sleep) ;
    _SymVal(GSymbol("$msleep"))->setfunc(bip_msleep) ;
    _SymVal(GSymbol("$usleep"))->setfunc(bip_usleep) ;
    _SymVal(GSymbol("$sleep_forever"))->setfunc(bip_sleep_forever) ;
    _SymVal(GSymbol("$fork"))->setfunc(bip_fork) ;
    _SymVal(GSymbol("$pid"))->setfunc(bip_pid) ;
    _SymVal(GSymbol("$newbarrier"))->setfunc(bip_newbarrier) ;
    _SymVal(GSymbol("$barrier_wait"))->setfunc(bip_barrier_wait) ;
    _SymVal(GSymbol("$barrier_signal"))->setfunc(bip_barrier_signal) ;
    _SymVal(GSymbol("$gensym"))->setfunc(bip_gensym) ;
    GenSymSeedSymbol = GSymbol("$g") ; ;
    _SymVal(GSymbol("$assign_gdbox"))->setfunc(bip_assign_gdbox) ;
    _SymVal(GSymbol("$gdbox_get"))->setfunc(bip_gdbox_get) ;
    _SymVal(GSymbol("$gdbox_put"))->setfunc(bip_gdbox_put) ;
    _SymVal(GSymbol("$var"))->setfunc(bip_var) ;
    _SymVal(GSymbol("$issymbol"))->setfunc(bip_issymbol) ;
    _SymVal(GSymbol("$isinteger"))->setfunc(bip_isinteger) ;
    _SymVal(GSymbol("$isfloat"))->setfunc(bip_isfloat) ;
    _SymVal(GSymbol("$isnumber"))->setfunc(bip_isnumber) ;
    _SymVal(GSymbol("$isstring"))->setfunc(bip_isstring) ;
    _SymVal(GSymbol("$ispointer"))->setfunc(bip_ispointerg) ;
    _SymVal(GSymbol("$term_arity"))->setfunc(bip_term_arity) ;
    _SymVal(GSymbol("$term_argv"))->setfunc(bip_term_argv) ;
    ConsSymbol = GSymbol("$") ;
    ConsCarVar = GVariable("_CAR") ;
    ConsCdrVar = GVariable("_CDR") ;
    ConsTerm = GTerm(ConsSymbol,ConsCarVar,ConsCdrVar) ;
    BasicCell = new GCell(GSymbol("basic")) ;
    MainCell = new GCell(GSymbol("main")) ;

} ;
