// -*- Mode:C++ -*-
//Header:
//File: splayer.cc
//Author: NODA Itsuki
//Date: 1998/6/23
//EndHeader:

//ModifyHistory:
// 1998/6/23: Create this file
//EndModifyHistory:

#include "splayer.h"
//#include "position.h"

#include "bipredutil.h"


//======================================================================
// Symbols
//

GData SideLeftSymbol ;
GData SideRightSymbol ;
GData PassSymbol ;
GData ClearSymbol ;
GData ShootSymbol ;

GData GoalSymbol ;
GData KickOffSymbol ;
GData HalfTimeSymbol ;
GData TimeExtendedSymbol ;
GData FoulSymbol ;
GData OffsideSymbol ;
GData DropBallSymbol ;
GData FreeKickSymbol ;
GData CornerKickSymbol ;
GData GoalKickSymbol ;
GData KickInSymbol ;
GData PlayOnSymbol ;
GData SelfSymbol ;
GData RefereeSymbol ;

GData Arg0Var ;
GData Arg1Var ;
GData Arg2Var ;
GData Arg3Var ;
GData Arg4Var ;
GData Arg5Var ;
GData Arg6Var ;
GData Arg7Var ;
GData Arg8Var ;

GData GoalTerm ;
GData GoalLTerm ;
GData GoalRTerm ;
GData KickOffLTerm ;
GData KickOffRTerm ;
GData KickInLTerm ;
GData KickInRTerm ;
GData GoalKickLTerm ;
GData GoalKickRTerm ;
GData CornerKickLTerm ;
GData CornerKickRTerm ;
GData FreeKickLTerm ;
GData FreeKickRTerm ;
GData FoulLTerm ;
GData FoulRTerm ;
GData OffsideLTerm ;
GData OffsideRTerm ;

//======================================================================
// Initializer
//

void splayerInit() {
   SideLeftSymbol = GSymbol("left") ;
   SideRightSymbol = GSymbol("right") ;
   PassSymbol = GSymbol("pass") ;
   ClearSymbol = GSymbol("clear") ;
   ShootSymbol = GSymbol("shoot") ;

   GoalSymbol = GSymbol("goal") ;
   KickOffSymbol = GSymbol("kick_off") ;
   HalfTimeSymbol = GSymbol("half_time") ;
   TimeExtendedSymbol = GSymbol("time_extended") ;
   FoulSymbol = GSymbol("foul") ;
   OffsideSymbol = GSymbol("offside") ;
   DropBallSymbol = GSymbol("drop_ball") ;
   FreeKickSymbol = GSymbol("free_kick") ;
   CornerKickSymbol = GSymbol("corner_kick") ;
   GoalKickSymbol = GSymbol("goal_kick") ;
   KickInSymbol = GSymbol("kick_in") ;
   PlayOnSymbol = GSymbol("play_on") ;
   SelfSymbol = GSymbol("self") ;
   RefereeSymbol = GSymbol("referee") ;

   Arg0Var = GVariable("Arg0") ;
   Arg1Var = GVariable("Arg1") ;
   Arg2Var = GVariable("Arg2") ;
   Arg3Var = GVariable("Arg3") ;
   Arg4Var = GVariable("Arg4") ;
   Arg5Var = GVariable("Arg5") ;
   Arg6Var = GVariable("Arg6") ;
   Arg7Var = GVariable("Arg7") ;
   Arg8Var = GVariable("Arg8") ;

   GoalTerm = GTerm(GoalSymbol,Arg0Var,Arg1Var) ;
   GoalLTerm = GTerm(GoalSymbol,SideLeftSymbol,Arg1Var) ;
   GoalRTerm = GTerm(GoalSymbol,SideRightSymbol,Arg1Var) ;
   KickOffLTerm = GTerm(KickOffSymbol,SideLeftSymbol) ;
   KickOffRTerm = GTerm(KickOffSymbol,SideRightSymbol) ;
   KickInLTerm = GTerm(KickInSymbol,SideLeftSymbol) ;
   KickInRTerm = GTerm(KickInSymbol,SideRightSymbol) ;
   GoalKickLTerm = GTerm(GoalKickSymbol,SideLeftSymbol) ;
   GoalKickRTerm = GTerm(GoalKickSymbol,SideRightSymbol) ;
   CornerKickLTerm = GTerm(CornerKickSymbol,SideLeftSymbol) ;
   CornerKickRTerm = GTerm(CornerKickSymbol,SideRightSymbol) ;
   FreeKickLTerm = GTerm(FreeKickSymbol,SideLeftSymbol) ;
   FreeKickRTerm = GTerm(FreeKickSymbol,SideRightSymbol) ;
   FoulLTerm = GTerm(FoulSymbol,SideLeftSymbol) ;
   FoulRTerm = GTerm(FoulSymbol,SideRightSymbol) ;
   OffsideLTerm = GTerm(OffsideSymbol,SideLeftSymbol) ;
   OffsideRTerm = GTerm(OffsideSymbol,SideRightSymbol) ;

   _SymVal(GSymbol("$s$get_new_message"))->setfunc(splay_get_new_message) ;

   _SymVal(GSymbol("$s$new_player"))->setfunc(splay_new_player) ;

   _SymVal(GSymbol("$s$send_move"))->setfunc(splay_send_move) ;
   _SymVal(GSymbol("$s$send_turn"))->setfunc(splay_send_turn) ;
   _SymVal(GSymbol("$s$send_turn_adir"))->setfunc(splay_send_turn_adir) ;
   _SymVal(GSymbol("$s$send_turn_apos"))->setfunc(splay_send_turn_apos) ;
   _SymVal(GSymbol("$s$send_dash"))->setfunc(splay_send_dash) ;
   _SymVal(GSymbol("$s$send_kick"))->setfunc(splay_send_kick) ;
   _SymVal(GSymbol("$s$send_kick_adir"))->setfunc(splay_send_kick_adir) ;
   _SymVal(GSymbol("$s$send_kick_apos"))->setfunc(splay_send_kick_apos) ;
   _SymVal(GSymbol("$s$send_say"))->setfunc(splay_send_say) ;
   _SymVal(GSymbol("$s$send_sense_body"))->setfunc(splay_send_sense_body) ;
   _SymVal(GSymbol("$s$send_catch"))->setfunc(splay_send_catch) ;

   _SymVal(GSymbol("$s$get_unum"))->setfunc(splay_get_unum) ;
   _SymVal(GSymbol("$s$get_side"))->setfunc(splay_get_side) ;

   _SymVal(GSymbol("$s$get_cpos"))->setfunc(splay_get_cpos) ;
   _SymVal(GSymbol("$s$get_bpos"))->setfunc(splay_get_bpos) ;
   _SymVal(GSymbol("$s$get_ppos"))->setfunc(splay_get_ppos) ;
   _SymVal(GSymbol("$s$get_ctime"))->setfunc(splay_get_ctime) ;
   _SymVal(GSymbol("$s$get_vtime"))->setfunc(splay_get_vtime) ;
   _SymVal(GSymbol("$s$get_atime"))->setfunc(splay_get_atime) ;
   _SymVal(GSymbol("$s$get_stime"))->setfunc(splay_get_stime) ;
   _SymVal(GSymbol("$s$get_rtime"))->setfunc(splay_get_rtime) ;
   _SymVal(GSymbol("$s$get_betime"))->setfunc(splay_get_betime) ;

   _SymVal(GSymbol("$s$wait_vinfo"))->setfunc(splay_wait_vinfo) ;
   _SymVal(GSymbol("$s$wait_ainfo"))->setfunc(splay_wait_ainfo) ;
   _SymVal(GSymbol("$s$wait_sinfo"))->setfunc(splay_wait_sinfo) ;

   _SymVal(GSymbol("$s$sensor_loop"))->setfunc(splay_sensor_loop) ;

   _SymVal(GSymbol("$s$chase_ball_simple"))->setfunc(splay_chase_ball_simple) ;
   _SymVal(GSymbol("$s$chase_ball_better"))->setfunc(splay_chase_ball_better) ;
   _SymVal(GSymbol("$s$new_pass_dst"))->setfunc(splay_new_pass_dst) ;
   _SymVal(GSymbol("$s$clear_pass_dst"))->setfunc(splay_clear_pass_dst) ;
   _SymVal(GSymbol("$s$add_pass_dst"))->setfunc(splay_add_pass_dst) ;
   _SymVal(GSymbol("$s$list_pass_dst"))->setfunc(splay_list_pass_dst) ;
   _SymVal(GSymbol("$s$chase_pass"))->setfunc(splay_chase_pass) ;
   _SymVal(GSymbol("$s$turn_look"))->setfunc(splay_turn_look) ;
   _SymVal(GSymbol("$s$goto_pos"))->setfunc(splay_goto_pos) ;

   _SymVal(GSymbol("$s$inside_rectangle"))->setfunc(splay_inside_rectangle) ;
   _SymVal(GSymbol("$s$shifted_pos"))->setfunc(splay_shifted_pos) ;
   _SymVal(GSymbol("$s$kickable"))->setfunc(splay_kickable) ;

}

//======================================================================
// Player class
//

bool Player::init(char* host, Int port, char* team, bool goalie) {
   gettimeofday(&startTime,NULLPTR) ;
   openConnection(host,port) ;
   bool r = sendInit(team,goalie) ;
   if(r) {
      objTable.init(side) ;
   }
   return r ;
}

bool Player::openConnection(char* host, Int port) {
   serverhost = host ;
   serverport = port ;
   sock = init_blocking_connection(host,port) ;
   return true ;
} 
     
bool Player::sendInit(char* team, bool goalie) {
   teamname = team ;
   if(goalie) {
      initInfo = send_com_init(&sock, team, (Bool)true, (Bool)true) ;
   } else {
      initInfo = send_com_init(&sock, team, (Bool)true, (Bool)false) ;
   }
   side = initInfo.side ;
   unum = initInfo.unum ;
   playmode = initInfo.playmode ;
   if(side == S_UNKNOWN) return false ;
   return true ;
} 

bool Player::updateVInfo() {
   ctime = sensorInfo.info.see.time ;
   ctimeBarrier.signal() ;
   vtime = ctime ;
   vtimeBarrier.signal() ;
   if(estimateCurrentPos()) {
      etime = ctime ;  
      updateObjTable() ;
      /* 
	 cout << "#[Pos(" << etime << ") ";
	 cout << "(" << currentPos.pos.x << ","
	 << currentPos.pos.y << ")" ;
	 cout << "<" << currentPos.dir << ">]" << endl ;
	 if(objTable.ball.etime == etime) {
	 cout << "#[Ball:(" << objTable.ball.apos.x ;
	 cout << "," << objTable.ball.apos.y << ")]" << endl ;
	 }
	 */
   }
} ;

bool Player::updateAInfo() {
   ctime = sensorInfo.info.hear.time ;
   ctimeBarrier.signal() ;
   atime = ctime ;
   atimeBarrier.signal() ;
   messageBuffer.push(&(sensorInfo.info.hear)) ;
} ;

bool Player::updateSBInfo() {
   ctime = sensorInfo.info.senseBody.time ;
   ctimeBarrier.signal() ;
   sbtime = ctime ;
   sbtimeBarrier.signal() ;
   sbInfo = sensorInfo.info.senseBody ;
} ;
     
bool Player::updateObjTable() {
   for(Int i = 0 ; i < sensorInfo.info.see.n_obj ; i++) {
      SeenObj* obj = &(sensorInfo.info.see.obj[i]) ;
      if(!obj->inViewConeP) continue ;
      switch(obj->type) {
	 case OT_Ball:
	    updateObjInfo(&(objTable.ball),obj) ; break ;
	 case OT_Goal:
	    if(obj->id.side == side)
	       updateObjInfo(&(objTable.owngoal),obj) ; 
	    else
	       updateObjInfo(&(objTable.goal),obj) ; 
	    break ;
	 case OT_Player:
	    if((obj->id.player.team == WT_Opponent) &&
	       (obj->id.player.unum != UNUM_ERR)) {
	       updateObjInfo(&(objTable.opponent[obj->id.player.unum-1]),
			     obj) ;
	    } else if ((obj->id.player.team == WT_Our) &&
		       (obj->id.player.unum != UNUM_ERR)) {
	       updateObjInfo(&(objTable.teammate[obj->id.player.unum-1]),
			     obj) ;
	    }
	    break ;
	 default:
	    break ;
      }
   }
   return true ;
} ;
		    
bool Player::updateObjInfo(ObjInfo* oinfo, SeenObj* sobj) {
   oinfo->seen.dist = sobj->dist ;
   oinfo->seen.dir = sobj->dir ;
   oinfo->seen.dist_chng = sobj->dist_chng ;
   oinfo->seen.dir_chng = sobj->dir_chng ;
   oinfo->adir = normalizeAngle(currentPos.dir + sobj->dir) ;
   oinfo->apos.x = 
      currentPos.pos.x + sobj->dist * Cos(oinfo->adir) ;
   oinfo->apos.y = 
      currentPos.pos.y + sobj->dist * Sin(oinfo->adir) ;
   oinfo->avec.x = 
      sobj->dist_chng * Cos(oinfo->adir) 
      - sobj->dist * sobj->dir_chng * DEG2RAD * Sin(oinfo->adir) ;
   oinfo->avec.y = 
      sobj->dist_chng * Sin(oinfo->adir) 
      - sobj->dist * sobj->dir_chng * DEG2RAD * Cos(oinfo->adir) ;
   oinfo->etime = ctime ;
} ;

//======================================================================
// Sensor process
//
void * sensorLoop(Player *player) {
   while(true) {
      sensorCycle(player) ;
   }
}

void sensorCycle(Player *player) {
   player->recvInfo() ;
   player->scanInfo() ;
   switch(player->sensorInfo.type) {
      case SIT_See: 
	 player->updateVInfo() ; break ;
      case SIT_Hear:
	 player->updateAInfo() ; break ;
      case SIT_SenseBody:
	 player->updateSBInfo() ; break ;
   }
}

     

//======================================================================
// listener process
//

inline int strncmp1(char* str1, char* str2) {
   return strncmp(str1,str2,strlen(str1)) ;
}
inline int strncmp2(char* str1, char* str2) {
   return strncmp(str1,str2,strlen(str2)) ;
}

GData senderSymbol(HearInfo* b) {
   switch(b->sender) {
      case ST_Self : 
	 return SelfSymbol ; 
      case ST_Referee :
	 return RefereeSymbol ;
      case ST_Player:
	 return GFloat(b->direction) ; 
      default:
	 return NullSymbol ;
   }
}

GData parseMessage(char* msg) {
   if      (!strncmp2(msg,"play_on")) 
      return PlayOnSymbol ;
   else if (!strncmp2(msg,"drop_ball")) 
      return DropBallSymbol ;
   else if (!strncmp2(msg,"half_time")) 
      return HalfTimeSymbol ;
   else if (!strncmp2(msg,"time_extended")) 
      return TimeExtendedSymbol ;
   else if (!strncmp2(msg,"kick_off_l")) 
      return KickOffLTerm ;
   else if (!strncmp2(msg,"kick_off_r")) 
      return KickOffRTerm ;
   else if (!strncmp2(msg,"kick_in_l")) 
      return KickInLTerm ;
   else if (!strncmp2(msg,"kick_in_r")) 
      return KickInRTerm ;
   else if (!strncmp2(msg,"goal_kick_l")) 
      return GoalKickLTerm ;
   else if (!strncmp2(msg,"goal_kick_r")) 
      return GoalKickRTerm ;
   else if (!strncmp2(msg,"corner_kick_l")) 
      return CornerKickLTerm ;
   else if (!strncmp2(msg,"corner_kick_r")) 
      return CornerKickRTerm ;
   else if (!strncmp2(msg,"free_kick_l")) 
      return FreeKickLTerm ;
   else if (!strncmp2(msg,"free_kick_r")) 
      return FreeKickRTerm ;
   else if (!strncmp2(msg,"foul_l")) 
      return FoulLTerm ;
   else if (!strncmp2(msg,"foul_r")) 
      return FoulRTerm ;
   else if (!strncmp2(msg,"offside_l")) 
      return OffsideLTerm ;
   else if (!strncmp2(msg,"offside_r")) 
      return OffsideRTerm ;
   else if (!strncmp2(msg,"goal_l")) 
      return GoalLTerm ;
   else if (!strncmp2(msg,"goal_r")) 
      return GoalRTerm ;
   else
      return GString(msg) ;
}

bool splay_get_new_message(Gem* gem) {
   /*	$s$get_new_message(+Player,-Time,-Sender,-MsgStr)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,4)) return bipFail(gem) ;

   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   InstGData timevar = _fetchedArgv(icgoal,1) ;
   InstGData sendervar = _fetchedArgv(icgoal,2) ;
   InstGData msgvar = _fetchedArgv(icgoal,3) ;

   if(player->messageBuffer.top <= player->listendTop)
      return bipFail(gem) ;
   
   HearInfo* b = player->messageBuffer.getBuf(player->listendTop) ;
   player->listendTop++ ;

   if(unifyWith(GInteger(b->time),timevar,gem) &&
      unifyWith(senderSymbol(b),sendervar,gem) &&
      unifyWith(parseMessage(b->message),msgvar,gem)) 
      return bipSuccess(gem) ;
   else
      return bipFail(gem) ;
}

#ifdef OLD_PLAYER

void * listenerLoop(Player *player) {
   while(true) {
      listenerCycle(player) ;
   }
}

void listenerCycle(Player *player) {
   player->waitAInfo() ;
   UInt top = player->messageBuffer.top ;
   for(UInt i = player->listendTop ; i < top ; i++) {
      HearInfo* b = player->messageBuffer.getBuf(i) ;
      if(player->VerboseP) {
	 cout << "[listen:" << player->unum << ":" << b->time << "(" ;
	 switch(b->sender) {
	    case ST_Self :
	       cout << "self" ; break ;
	    case ST_Referee :
	       cout << "referee" ; break ;
	    case ST_Player:
	       cout << "player<" << b->direction << ">" ; break ;
	    default:
	       cout << "unknown" ;
	 }
	 cout << ")|" ;
	 cout << b->message << "]" << endl ;
      }
      if(b->sender == ST_Referee) {
	 if(!strncmp2(b->message,"goal_l")||
	    !strncmp2(b->message,"goal_r")||
	    !strncmp2(b->message,"half_time")||
	    !strncmp2(b->message,"time_extended")) {
	    player->wKickOffTime = b->time ;
	    player->smach.repushEnv(GS_C_WaitPlayOn) ;
	    player->smach.repushEnv(GS_C_MovetoHome) ;
	 }
      }
   }
   player->listendTop = top ;
}

#endif


//======================================================================
// predicate function
//

//--------------------------------------------------
// new player

bool splay_new_player(Gem* gem) { 
   /*	$s$new_player(-Player,+Team,+Host,+Port)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,4)) {
      InstGData var = _fetchedArgv(icgoal,0) ;
      GData team = fetchedArgv(icgoal,1) ;
      GData host = fetchedArgv(icgoal,2) ;
      GData port = fetchedArgv(icgoal,3) ;

      if(!(isGSymbol(team)||isGString(team))) 
	 return bipError(gem, "Illegal team name") ;
      if(!(isGSymbol(host)||isGString(host)))
	 return bipError(gem, "Illegal host name") ;
      if(!isGInteger(port))
	 return bipError(gem, "Illegal port number") ;

      Player* player = new Player ;
      char* teamstr; char* hoststr ;

      if(isGSymbol(team)) 
	 teamstr = (char*)(_SymVal(team)->name) ;
      else
	 teamstr = (char*)(*_StrVal(team)) ;
      if(isGSymbol(host))
	 hoststr = (char*)(_SymVal(host)->name) ;
      else 
	 hoststr = (char*)(*_StrVal(host)) ;

      bool r = player->init(hoststr,IntVal(port),teamstr,false) ;

      if(!r) {
	 delete player ;
	 return bipError(gem,"Can not open splayer connection") ;
      }

      if(unifyWith(GPointer(player),var,gem)) {
	 return bipSuccess(gem) ;
      } else {
	 delete player ;
	 return bipFail(gem) ;
      }
   }
   return bipFail(gem) ;
}
	 
//--------------------------------------------------
// move

bool splay_send_move(Gem* gem) { 
   /*	$s$send_move(+Player,+X,+Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,3)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData x = fetchedArgv(icgoal,1) ;
      GData y = fetchedArgv(icgoal,2) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(x)) return bipError(gem,"Wrong pos_x value") ;
      if(!isGNumber(y)) return bipError(gem,"Wrong pos_y value") ;

      bool r = ((Player*)_PtrVal(p))->sendMove(FltVal(x),FltVal(y)) ;
      if(r) {
	 return bipSuccess(gem) ;
      } else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// turn

bool splay_send_turn(Gem* gem) { 
   /*	$s$send_turn(+Player,+Power)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData m = fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(m)) return bipError(gem,"Wrong power value") ;

      ((Player*)_PtrVal(p))->sendTurn(FltVal(m)) ;
      
      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// turn adir

bool splay_send_turn_adir(Gem* gem) { 
   /*	$s$send_turn_adir(+Player,+ADir)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData d = fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(d)) return bipError(gem,"Wrong adir value") ;

      ((Player*)_PtrVal(p))->sendTurnAbs(FltVal(d)) ;
      
      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// turn adir

bool splay_send_turn_apos(Gem* gem) { 
   /*	$s$send_turn_apos(+Player,+X,+Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,3)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData x = fetchedArgv(icgoal,1) ;
      GData y = fetchedArgv(icgoal,2) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(x)) return bipError(gem,"Wrong pos x value") ;
      if(!isGNumber(y)) return bipError(gem,"Wrong pos y value") ;

      Pos pos ; pos.x = FltVal(x) ; pos.y = FltVal(y) ;
      ((Player*)_PtrVal(p))->sendTurnAbs(pos) ;
      
      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// dash

bool splay_send_dash(Gem* gem) { 
   /*	$s$send_dash(+Player,+Power)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData pow = fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(pow)) return bipError(gem,"Wrong power value") ;

      ((Player*)_PtrVal(p))->sendDash(FltVal(pow)) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// kick

bool splay_send_kick(Gem* gem) { 
   /*	$s$send_kick(+Player,+Power,+Dir)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,3)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData pow = fetchedArgv(icgoal,1) ;
      GData dir = fetchedArgv(icgoal,2) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(pow)) return bipError(gem,"Wrong power value") ;
      if(!isGNumber(dir)) return bipError(gem,"Wrong dir value") ;

      ((Player*)_PtrVal(p))->sendKick(FltVal(pow),FltVal(dir)) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// kick adir

bool splay_send_kick_adir(Gem* gem) { 
   /*	$s$send_kick_adir(+Player,+Power,+ADir)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,3)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData pow = fetchedArgv(icgoal,1) ;
      GData dir = fetchedArgv(icgoal,2) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(pow)) return bipError(gem,"Wrong power value") ;
      if(!isGNumber(dir)) return bipError(gem,"Wrong adir value") ;

      ((Player*)_PtrVal(p))->sendKickAbs(FltVal(pow),FltVal(dir)) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// kick apos

bool splay_send_kick_apos(Gem* gem) { 
   /*	$s$send_kick_apos(+Player,+Power,+X,+Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,4)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData pow = fetchedArgv(icgoal,1) ;
      GData x = fetchedArgv(icgoal,2) ;
      GData y = fetchedArgv(icgoal,3) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(pow)) return bipError(gem,"Wrong power value") ;
      if(!isGNumber(x)) return bipError(gem,"Wrong pos x value") ;
      if(!isGNumber(y)) return bipError(gem,"Wrong pos y value") ;

      Pos pos ; pos.x = FltVal(x) ; pos.y = FltVal(y) ;
      ((Player*)_PtrVal(p))->sendKickAbs(FltVal(pow),pos) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// say

bool splay_send_say(Gem* gem) { 
   /*	$s$send_say(+Player,+Msg)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData msg = fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGSymbol(msg) && !isGString(msg)) 
	 return bipError(gem,"Wrong power value") ;

      char* msgstr ;
      if(isGSymbol(msg)) msgstr = (char*)(_SymVal(msg)->name) ;
      else msgstr = (char*)(*_StrVal(msg)) ;

      ((Player*)_PtrVal(p))->sendSay(msgstr) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// sense body

bool splay_send_sense_body(Gem* gem) { 
   /*	$s$send_sense_body(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,1)) {
      GData p = fetchedArgv(icgoal,0) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      ((Player*)_PtrVal(p))->sendSenseBody() ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// catch

bool splay_send_catch(Gem* gem) { 
   /*	$s$send_catch(+Player,+Dir)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      GData dir = fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
      if(!isGNumber(dir)) return bipError(gem,"Wrong dir value") ;

      ((Player*)_PtrVal(p))->sendCatch(FltVal(dir)) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get unum

bool splay_get_unum(Gem* gem) { 
   /*	$s$get_unum(+Player,-UNum)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData unum = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->unum),unum,gem)) 
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get side

bool splay_get_side(Gem* gem) { 
   /*	$s$get_side(+Player,-Side)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData var = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      GData side ;
      if(player->side == S_LEFT) 
	 side = SideLeftSymbol ;
      else
	 side = SideRightSymbol ;

      if(unifyWith(side,var,gem)) 
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get cpos

bool splay_get_cpos(Gem* gem) { 
   /*	$s$get_cpos(+Player,-X,-Y,-Dir)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,4)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vx = _fetchedArgv(icgoal,1) ;
      InstGData vy = _fetchedArgv(icgoal,2) ;
      InstGData vd = _fetchedArgv(icgoal,3) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;
      PosState cpos = player->currentPos ;

      if(unifyWith(GFloat(cpos.pos.x),vx,gem) && 
	 unifyWith(GFloat(cpos.pos.y),vy,gem) &&
	 unifyWith(GFloat(cpos.dir),vd,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get bpos

bool splay_get_bpos(Gem* gem) { 
   /*	$s$get_bpos(+Player,-X,-Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,3)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vx = _fetchedArgv(icgoal,1) ;
      InstGData vy = _fetchedArgv(icgoal,2) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;
      Pos bpos = player->objTable.ball.apos ;

      if(unifyWith(GFloat(bpos.x),vx,gem) && 
	 unifyWith(GFloat(bpos.y),vy,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get ppos

bool splay_get_ppos(Gem* gem) { 
   /*	$s$get_ppos(+Player,+Team,+UNum,-X,-Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   /* this is not implemented */
   return bipFail(gem) ;
} 

//--------------------------------------------------
// get ctime

bool splay_get_ctime(Gem* gem) { 
   /*	$s$get_ctime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->ctime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get atime

bool splay_get_atime(Gem* gem) { 
   /*	$s$get_atime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->atime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get vtime

bool splay_get_vtime(Gem* gem) { 
   /*	$s$get_vtime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->vtime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get stime

bool splay_get_stime(Gem* gem) { 
   /*	$s$get_stime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->sbtime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get rtime

bool splay_get_rtime(Gem* gem) { 
   /*	$s$get_rtime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->rtime()),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get etime

bool splay_get_etime(Gem* gem) { 
   /*	$s$get_etime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->etime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// get betime

bool splay_get_betime(Gem* gem) { 
   /*	$s$get_betime(+Player,-Time)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,2)) {
      GData p = fetchedArgv(icgoal,0) ;
      InstGData vt = _fetchedArgv(icgoal,1) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(unifyWith(GInteger(player->objTable.ball.etime),vt,gem))
	 return bipSuccess(gem) ;
      else
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// wait vinfo

bool splay_wait_vinfo(Gem* gem) { 
   /*	$s$wait_vinfo(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,1)) {
      GData p = fetchedArgv(icgoal,0) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(player->waitVInfo()) 
	 return bipSuccess(gem) ;
      else 
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// wait ainfo

bool splay_wait_ainfo(Gem* gem) { 
   /*	$s$wait_ainfo(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,1)) {
      GData p = fetchedArgv(icgoal,0) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(player->waitAInfo()) 
	 return bipSuccess(gem) ;
      else 
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// wait sinfo

bool splay_wait_sinfo(Gem* gem) { 
   /*	$s$wait_sinfo(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,1)) {
      GData p = fetchedArgv(icgoal,0) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      if(player->waitSBInfo()) 
	 return bipSuccess(gem) ;
      else 
	 return bipFail(gem) ;
   }
   return bipFail(gem) ;
}

//--------------------------------------------------
// sensor loop

bool splay_sensor_loop(Gem* gem) { 
   /*	$s$sensor_loop(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(chkArity(cgoal,1)) {
      GData p = fetchedArgv(icgoal,0) ;

      if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;

      Player* player = (Player*)_PtrVal(p) ;

      player->sensorProcess = gem ;

      sensorLoop(player) ;

      return bipSuccess(gem) ;
   }
   return bipFail(gem) ;
}


//======================================================================
// Basic Actions
//

bool objectExistP(Player* player) {
   Pos& ppos = player->currentPos.pos ;
   Pos& bpos = player->objTable.ball.apos ;
   Float bdist = dist(ppos,bpos) ;
   Float dd = Min(bdist,2) ;
   Int ctime = player->ctime ;
     
   for(Int i = 0 ; i < 11 ; i++) {
      if(ctime - player->objTable.opponent[i].etime > 5) continue ;
      Pos& opos = player->objTable.opponent[i].apos ;
      Float odist = dist(ppos,opos) ;
      if(odist < dd) {
	 Float odir = Atan2(opos.y - ppos.y,opos.x - ppos.x) ;
	 if(fabs(odist * Sin(odir)) < PLAYERSIZE * 2) 
	    return true ;
      }
      if(ctime - player->objTable.opponent[i].etime > 5) continue ;
      if(i != player->unum-1) {
	 Pos& tpos = player->objTable.teammate[i].apos ;
	 Float tdist = dist(ppos,tpos) ;
	 if(tdist < dd) {
	    Float tdir = Atan2(tpos.y - ppos.y,tpos.x - ppos.x) ;
	    if(fabs(tdist * Sin(tdir)) < PLAYERSIZE * 2) 
	       return true ;
	 }
      }
   }
   return false ;
}

bool avoidAction(Player* player) {
   if(objectExistP(player)) {
      if(player->VerboseP) cout << "Avoid!!" << endl ;
      if(player->ctime % 2) {
	 player->sendTurn(90,120) ;
	 player->sendDash(100,200) ;
	 player->sendTurn(-90,100) ;
      } else {
	 player->sendTurn(-90,120) ;
	 player->sendDash(100,200) ;
	 player->sendTurn(90,100) ;
      }
      return true ;
   } 
   return false ;
}

bool splay_chase_ball_simple(Gem* gem) {
   /*	$s$chase_ball_simple(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   if(player->ctime < 1) return bipFail(gem) ;
   if((player->ctime - player->objTable.ball.etime < 10) &&
      player->ballKickable()) {
      player->sendKickAbs(100,player->objTable.goal.apos,100) ;
      player->sendTurnAbs(player->objTable.goal.apos,100) ;
      return bipSuccess(gem) ;
   } 
   player->sendTurnAbs(player->objTable.ball.apos,100) ;
   player->sendDash(100,100) ;
   return bipSuccess(gem) ;
}

bool splay_chase_ball_better(Gem* gem) { 
   /*	$s$chase_ball_better(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   if(player->ctime < 1) return bipFail(gem) ;
   if((player->ctime - player->objTable.ball.etime < 10) &&
      player->ballKickable()) {
      player->sendKickAbs(100,player->objTable.goal.apos,100) ;
      player->sendTurnAbs(player->objTable.goal.apos,100) ;
      return bipSuccess(gem) ;
   } 
   Pos gpos = player->objTable.ball.apos ;
   gpos.x = gpos.x - 1 ;
   player->sendTurnAbs(gpos,100) ;
   player->sendDash(50,100) ;
   return bipSuccess(gem) ;
}

bool splay_new_pass_dst(Gem* gem) {
   /*	$s$new_pass_dst(+Player,Size)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,2)) return bipFail(gem) ;

   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   GData len = fetchedArgv(icgoal,1) ;
   if(!isGInteger(len)) return bipError(gem,"Illegal number.") ;
   player->passToMax = IntVal(len) ;
   player->passToN = 0 ;
   player->passTo = new PassInfo[IntVal(len)] ;
   
   return bipSuccess(gem) ; 
} 

bool splay_clear_pass_dst(Gem* gem) {
   /*	$s$clear_pass_dst(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;

   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   player->passToN = 0 ;
   return bipSuccess(gem) ; 
} 

bool splay_add_pass_dst(Gem* gem) {
   /*	$s$add_pass_dst_max(+Player,X,Y,Type)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,4)) return bipFail(gem) ;

   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   GData x = fetchedArgv(icgoal,1) ;
   GData y = fetchedArgv(icgoal,2) ;
   if(!isGNumber(x) || !isGNumber(y)) return bipError(gem,"Illegal number.") ;

   GData type = fetchedArgv(icgoal,3) ;
   PassInfo::KickType ktype ;
   if     (eq(type,PassSymbol)) ktype = PassInfo::KT_pass ;
   else if(eq(type,ClearSymbol)) ktype = PassInfo::KT_clear ;
   else if(eq(type,ShootSymbol)) ktype = PassInfo::KT_shoot ;
   else return bipError(gem,"Illegal kick type") ;
   
   PassInfo* pinfo = &(player->passTo[player->passToN]) ;
   pinfo->pos.x = FltVal(x) ;
   pinfo->pos.y = FltVal(y) ;
   pinfo->type = ktype ;
   player->passToN++ ;
   
   return bipSuccess(gem) ; 
} 

bool splay_list_pass_dst(Gem* gem) {
   /*	$s$list_pass_dst(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;

   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   for(Int i = 0 ; i < player->passToN ; i++) {
      cout << i << ":\t(" << player->passTo[i].pos.x 
	   << "," << player->passTo[i].pos.y << ")" 
	   << player->passTo[i].type << endl ;
   }

   return bipSuccess(gem) ; 
} 

inline Float absAngle(Pos& org, Pos& target) {
   return Atan2((target.y - org.y),(target.x - org.x)) ;
}

inline Float diffAngle(Pos& org, Pos& reference, Pos& target) {
   return normalizeAngle(absAngle(org,target) - absAngle(org,reference)) ;
}

Pos findGoodPassDir(Player* player) {
   PassInfo* target = NULLPTR ;
   Float dAng = 720.0 ;
   ObjInfo* ball = &(player->objTable.ball) ;
     
   for(Int i = 0 ; i < player->passToN ; i++) {
      PassInfo* t = &(player->passTo[i]) ;
      if(t->pos.x < player->currentPos.pos.x) continue ;
      Float dA = fabs(diffAngle(player->currentPos.pos,
				ball->apos,t->pos)) ;
      if(t->type == PassInfo::KT_clear) dA = dA * 2.0 + 90.0 ;
      if(dAng < dA) continue ;
      target = t ;
      dAng = dA ;
   }
   if(target == NULLPTR) target = &(player->passTo[0]) ; 
   if(player->VerboseP) {
      cout << "[" << player->unum << "] I pass to (" << target->pos.x 
	   << "," << target->pos.y
	   << ")." << endl ;
   }
   return target->pos ;
}

bool splay_chase_pass(Gem* gem) {
   /*	$s$chase_pass(+Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   if(player->ctime < 1) return bipFail(gem) ;
   if((player->ctime - player->objTable.ball.etime < 3) &&
      player->ballKickable()) {
      Pos dpos = findGoodPassDir(player) ;
      player->sendKickAbs(100,dpos,100) ;
      player->sendTurnAbs(dpos,100) ;
      return bipSuccess(gem) ;
   } 
   Pos gpos = player->objTable.ball.apos ;
   // predict ball pos
#ifndef NOPREDICT
   Pos gvec = player->objTable.ball.avec ;
   Float gdist = player->objTable.ball.seen.dist ;
   Float gvdir = Atan2(gvec.y,gvec.x) ;
   Float gdir = absAngle(player->currentPos.pos, gpos) ;
   Float a = fabs(Sin(gvdir - gdir) * gdist * player->PredFactor);
   gpos.x += a * gvec.x ;
   gpos.y += a * gvec.y ;
   if(player->VerboseP)
      cout << "[pred:" << a << " * (" << gvec.x << "," << gvec.y << ")]" 
	   << endl ;
#endif
   //
   gpos.x = gpos.x - 1 ;
   player->sendTurnAbs(gpos,100) ;
   avoidAction(player) ;
   player->sendDash(player->DashPower,100) ;
   return bipSuccess(gem) ;
}     
     
bool splay_turn_look(Gem* gem) {
   /*	$s$turn_look(+Player,+Angle)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,2)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   GData angle = fetchedArgv(icgoal,1) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   player->sendTurn(FltVal(angle)) ;
   player->waitVInfo() ;
}
/****
bool sWaitKickOff(StackMachine *smach) {
   Player* player = smach->player ;
   GData cdt = smach->opStack.pop() ;
   Int c = IntVal(cdt) ;
   if(VerboseP)
      cout << "Waiting Kick Off!! [" << player->unum << ":" 
	   << player->wKickOffTime << "==" << player->ctime << "]" << endl ;
   if(c <= 0) {
      c = 0 ;
      player->wKickOffTime = player->ctime ;
   }
   if(player->wKickOffTime < player->ctime) {
      player->wKickOffTime = -1 ;
      return true ;
   }
   smach->opStack.push(GS_TurnLook, GS_WaitKickOff, GInteger(c+1)) ;
   return false ;
}
****/

/*****
bool sWaitKickOffQuit(StackMachine *smach) {
   smach->opStack.push(GS_WaitKickOff,GInteger(0),GS_QuitWaitKickOff) ;
   return true ;
}
****/

/*****
bool sQuitWaitKickOff(StackMachine *smach) {
   smach->removeEnv(GS_C_WaitPlayOn) ;
   return true ;
}
****/

/*****
bool sMovetoHome(StackMachine *smach) {
   Player* player = smach->player ;
   if(VerboseP) 
      cout << "[MovetoHome:" << player->unum << "]" << endl ;
   smach->removeEnv(GS_C_MovetoHome) ;
   MSleep(100) ;
   player->sendMove(player->posInfo->spos.x, player->posInfo->spos.y) ;
   MSleep(100) ;
   player->sendMove(player->posInfo->spos.x, player->posInfo->spos.y) ;
   MSleep(100) ;
   player->sendMove(player->posInfo->spos.x, player->posInfo->spos.y) ;
   return true ;
}
****/

 
bool splay_goto_pos(Gem* gem) {
   /*	$s$goto_pos(+Player,+X,+Y)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,3)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   GData xdt = fetchedArgv(icgoal,1) ;
   GData ydt = fetchedArgv(icgoal,2) ;
   Float x = FltVal(xdt) ;
   Float y = FltVal(ydt) ;

   Pos targetPos = xyP(x,y) ;
   bool backp = false ;
   //back?
   Pos ppos = player->currentPos.pos ;
   Float ddir = diffAngle(ppos,player->objTable.ball.apos,targetPos) ;
   if(fabs(ddir) > 90.0) backp = true ;
   //

   player->sendTurnAbs(targetPos,100,backp) ;
   if(dist(player->currentPos.pos,targetPos)>10) {
      player->sendDash(20,100,backp) ;
   } else {
      player->sendDash(10,100,backp) ;
   }

   return bipSuccess(gem) ;
}

inline Pos shiftedHomePos(const Pos& hpos, const Pos& bpos, const Pos& spos,
			  Float sfactor) 
{
   Pos pos = hpos;
   pos.x += bpos.x * sfactor * spos.x 
      / FIELDHALFLENGTH ;
   pos.y += bpos.y * sfactor * spos.y
      / FIELDHALFWIDTH ;
   if(pos.x < -(FIELDHALFLENGTH - 0.5)) 
      pos.x = -(FIELDHALFLENGTH - 0.5) ;

   return pos ;
}

bool splay_kickable(Gem* gem) {
   /*	$s$kickable(Player)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,1)) return bipFail(gem) ;
   GData p = fetchedArgv(icgoal,0) ;
   if(!isGPointer(p)) return bipError(gem,"Illegal player object.") ;
   Player* player = (Player*)_PtrVal(p) ;

   if(player->ballKickable()) {
      return bipSuccess(gem) ;
   } else 
      return bipFail(gem) ;
}



bool splay_shifted_pos(Gem* gem) {
   /*	$s$shifted_pos(-X,-Y,+HX,+HY,+BX,+BY,+SX,+SY,+SF) */

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,9)) return bipFail(gem) ;

   InstGData x = _fetchedArgv(icgoal,0) ;
   InstGData y = _fetchedArgv(icgoal,1) ;

   GData hx = fetchedArgv(icgoal,2) ;
   GData hy = fetchedArgv(icgoal,3) ;
   GData bx = fetchedArgv(icgoal,4) ;
   GData by = fetchedArgv(icgoal,5) ;
   GData sx = fetchedArgv(icgoal,6) ;
   GData sy = fetchedArgv(icgoal,7) ;
   GData sf = fetchedArgv(icgoal,8) ;

   if(!isGNumber(hx) || !isGNumber(hy) ||
      !isGNumber(bx) || !isGNumber(by) ||
      !isGNumber(sx) || !isGNumber(sy) ||
      !isGNumber(sf))
      return bipError(gem,"Illegal Number") ;

   Pos pos = shiftedHomePos(xyP(FltVal(hx),FltVal(hy)),
			    xyP(FltVal(bx),FltVal(by)),
			    xyP(FltVal(sx),FltVal(sy)),FltVal(sf)) ;
   if(unifyWith(GFloat(pos.x),x,gem) && unifyWith(GFloat(pos.y),y,gem))
      return bipSuccess(gem) ;
   else
      return bipFail(gem) ;
}

/****
bool sGotoHome(StackMachine *smach) {
   Player* player=smach->player ;

   Pos hpos = shiftedHomePos(player) ;
   GData xdt = GFloat(hpos.x) ;
   GData ydt = GFloat(hpos.y) ;

   smach->opStack.push(GS_GotoPos, xdt, ydt) ;

   return true ;
}
****/

inline bool inside_rectangle(const Pos& pos, 
			     const Pos& center, 
			     const Pos& range) {
   if(fabs(pos.x - center.x) > range.x) return false ;
   if(fabs(pos.y - center.y) > range.y) return false ;
   return true ;
}

bool splay_inside_rectangle(Gem* gem) {
   /*	$s$inside_rectangle(+PX,+PY,+CX,+CY,+RX,+RY)	*/

   InstGData icgoal = gem->currentGoal() ;
   GData cgoal = icgoal.data ;

   if(!chkArity(cgoal,6)) return bipFail(gem) ;

   GData px = fetchedArgv(icgoal,0) ;
   GData py = fetchedArgv(icgoal,1) ;
   GData cx = fetchedArgv(icgoal,2) ;
   GData cy = fetchedArgv(icgoal,3) ;
   GData rx = fetchedArgv(icgoal,4) ;
   GData ry = fetchedArgv(icgoal,5) ;

   if(   !isGNumber(px) || !isGNumber(py) 
      || !isGNumber(cx) || !isGNumber(cy) 
      || !isGNumber(rx) || !isGNumber(ry)) 
      return bipError(gem,"Illegal Number") ;

   if(inside_rectangle(xyP(FltVal(px),FltVal(py)),
		       xyP(FltVal(cx),FltVal(cy)),
		       xyP(FltVal(rx),FltVal(ry)))) 
      return bipSuccess(gem) ;
   else
      return bipFail(gem) ;

}
      
   
