#define NULL 0
#include <iostream.h>
#include "gc.h"
#include "gdata.h"
#include "gbio.h"

#include "gcell.h"
#include "unify.h"

int test1() { /* sizeof */
   printf("GData=%d\n",sizeof(GData)) ; 
   printf("GDValue=%d\n",sizeof(GDValue)) ; 
   printf("GDType=%d\n",sizeof(GDType)) ; 
   printf("Int=%d\n",sizeof(Int)) ; 
   printf("Float=%d\n",sizeof(Float)) ; 
   printf("Term=%d\n",sizeof(Term)) ; 
   printf("Symbol=%d\n",sizeof(Symbol)) ; 
   printf("Pointer=%d\n",sizeof(void *)) ; 
}

int test2() { /* gdata */
   GInteger a(3);  		
   cout << a << " : " ; a.describe() ;
   GFloat b(4.3);
   cout << b << " : " ; b.describe() ;
   Symbol c("aho") ;
   cout << c << " : " ; c.describe() ;
   Term d(&c,a,b) ;
   cout << d << " : " ; d.describe() ;
   GData e ; e = a ;
   cout << e << " : " ; e.describe() ;
   GData f ; f = (GData)a ;
   cout << f << " : " ; f.describe() ;
   GSymbol g("aho") ;
   cout << g << " : " ; g.describe() ;
   GSymbol h("baka") ;
   cout << h << " : " ; h.describe() ;
   GSymbol i("aho") ;
   cout << i << " : " ; i.describe() ;
   GVariable j("Boke") ;
   cout << j << " : " ; j.describe() ;
   GVariable k("aho") ;
   cout << k << " : " ; k.describe() ;

   cout << "-------------------" << endl ;
}

int test3() { /* gbio */
   GData l = readGData(cin) ;
   cout << l << ":" ; l.describe() ;

   GData m = readGData("a(b,c(e,a),1.2,'a,b,c,d',\"a.  '\",0x3f4)") ;
   cout << m << ":" ; m.describe() ;

} 

int test4() { /* gensym */
   GData x = genGSymbol() ;
   GData x1 = genGSymbol(x) ;
   x.describe() ;
   x1.describe() ;

   GData y = genGVariable() ;
   GData y1 = genGVariable(y) ;
   y.describe() ;
   y1.describe() ;
} 

int test5() { /* unify */
   UnifyInfoHeap uiheap ;
   cout << uiheap ;

   GData x = readGData("a(X,X,Y)") ;
   GData y = readGData("a(c(Y),Y,c(Y))") ;

   Binding* xbinding = uiheap.newBinding() ;
   Binding* ybinding = uiheap.newBinding() ;

   cout << *xbinding << endl ;

   BindingState bstate ;
   memoryBindingState(bstate,xbinding,&uiheap) ;
   bool r = unify(InstGData(x,xbinding),InstGData(y,ybinding),&uiheap) ;
   if(!r) rewindBindingState(&bstate,xbinding,&uiheap);
     
   if(r) { cout << "Unify succeed." << endl; } 
   else  { cout << "Unify fail." << endl ; }
	  
   cout << *xbinding << endl ;
   cout << *ybinding << endl ;

   GData rv = fetchValue(InstGData(x,xbinding),&uiheap) ;

   cout << rv << endl ;
   rv.describe() ;
}

int main(int argc, char** argv) {
   gglobalInit() ;
   
//     test1() ;
//     test2() ;
//     test3() ;
//     test4() ;     test4() ;
   test5() ;
}
